import DebugLogger from "debug";
import { createProxyFunction } from "../common/call-proxy";
import { RemoteCallback } from "../common/callbacks";
const debug = DebugLogger("threads:callback:messages");
export const DefaultCallbackSerializer = (rootSerializer) => ({
    deserialize(message, origin) {
        const proxy = createProxyFunction(origin, rootSerializer, message.fid, debug);
        return RemoteCallback(proxy);
    },
    serialize(callback) {
        return {
            __callback_marker: "$$callback",
            fid: callback.id
        };
    }
});
export const isSerializedCallback = (thing) => thing && typeof thing === "object" && "__callback_marker" in thing && thing.__callback_marker === "$$callback";
