/// <reference lib="dom" />
// tslint:disable no-shadowed-variable
import { multiplexEventTarget } from "../util/events";
const isWorkerRuntime = function isWorkerRuntime() {
    const isWindowContext = typeof self !== "undefined" && typeof Window !== "undefined" && self instanceof Window;
    return typeof self !== "undefined" && self.postMessage && !isWindowContext ? true : false;
};
const postMessage = function postMessageToMaster(data, transferList) {
    self.postMessage(data, transferList);
};
let muxedSelfEvents;
const Implementation = {
    addEventListener(event, handler) {
        muxedSelfEvents = muxedSelfEvents || multiplexEventTarget(self);
        return muxedSelfEvents.addEventListener(event, handler);
    },
    removeEventListener(event, handler) {
        muxedSelfEvents = muxedSelfEvents || multiplexEventTarget(self);
        return muxedSelfEvents.removeEventListener(event, handler);
    },
    isWorkerRuntime,
    postMessage
};
export default Implementation;
