import WorkerThreads from "../worker_threads";
function assertMessagePort(port) {
    if (!port) {
        throw Error("Invariant violation: MessagePort to parent is not available.");
    }
    return port;
}
const isWorkerRuntime = function isWorkerRuntime() {
    return !WorkerThreads().isMainThread;
};
const postMessage = function postMessage(data, transferList) {
    assertMessagePort(WorkerThreads().parentPort).postMessage(data, transferList);
};
function testImplementation() {
    // Will throw if `worker_threads` are not available
    WorkerThreads();
}
const Implementation = {
    addEventListener(event, listener) {
        const port = assertMessagePort(WorkerThreads().parentPort);
        return event === "message"
            ? port.on(event, (data) => listener({ data }))
            : port.on(event, listener);
    },
    removeEventListener(event, listener) {
        const port = assertMessagePort(WorkerThreads().parentPort);
        return port.off(event, listener);
    },
    isWorkerRuntime,
    postMessage,
    testImplementation
};
export default Implementation;
