import { $callback } from "../symbols";
export interface Callback<Fn extends (...args: any[]) => any = (...args: any[]) => any> {
    (...args: Parameters<Fn>): ReturnType<Fn>;
    [$callback]: true;
    id: number;
    release(): void;
}
export declare function isCallback(thing: any): thing is Callback<any>;
export declare function lookupLocalCallback(id: number): Callback<any> | undefined;
export declare function lookupRemoteCallback(id: number): Callback<(...args: any[]) => any> | undefined;
export declare function Callback<Fn extends (...args: any[]) => any>(fn: Fn): Callback<any>;
export declare function RemoteCallback<Fn extends (...args: any[]) => any>(fn: Fn): Callback<Fn>;
export declare function SingleExposedCallback<Fn extends (...args: any[]) => any>(fn: Fn): Callback<any>;
