"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serialize = exports.deserialize = exports.registerSerializer = exports.getRegisteredSerializer = void 0;
const index_1 = require("../serializers/index");
let registeredSerializer = index_1.DefaultSerializer();
function getRegisteredSerializer() {
    return registeredSerializer;
}
exports.getRegisteredSerializer = getRegisteredSerializer;
function registerSerializer(serializer) {
    registeredSerializer = index_1.extendSerializer(registeredSerializer, serializer);
}
exports.registerSerializer = registerSerializer;
function deserialize(message, origin) {
    return registeredSerializer.deserialize(message, origin);
}
exports.deserialize = deserialize;
function serialize(input) {
    return registeredSerializer.serialize(input);
}
exports.serialize = serialize;
