"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSerializedCallback = exports.DefaultCallbackSerializer = void 0;
const debug_1 = __importDefault(require("debug"));
const call_proxy_1 = require("../common/call-proxy");
const callbacks_1 = require("../common/callbacks");
const debug = debug_1.default("threads:callback:messages");
exports.DefaultCallbackSerializer = (rootSerializer) => ({
    deserialize(message, origin) {
        const proxy = call_proxy_1.createProxyFunction(origin, rootSerializer, message.fid, debug);
        return callbacks_1.RemoteCallback(proxy);
    },
    serialize(callback) {
        return {
            __callback_marker: "$$callback",
            fid: callback.id
        };
    }
});
exports.isSerializedCallback = (thing) => thing && typeof thing === "object" && "__callback_marker" in thing && thing.__callback_marker === "$$callback";
