"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSerializedIterator = exports.isIterator = exports.DefaultIteratorSerializer = void 0;
const debug_1 = __importDefault(require("debug"));
const call_proxy_1 = require("../common/call-proxy");
const callbacks_1 = require("../common/callbacks");
const debug = debug_1.default("threads:callback:messages");
exports.DefaultIteratorSerializer = (rootSerializer) => ({
    deserialize(message, origin) {
        const remoteNext = call_proxy_1.createProxyFunction(origin, rootSerializer, message.next_fid, debug);
        const remoteCallback = callbacks_1.RemoteCallback(remoteNext);
        const next = () => __awaiter(this, void 0, void 0, function* () {
            const result = yield remoteCallback();
            if (result.done) {
                remoteCallback.release();
            }
            return result;
        });
        const asyncIterator = {
            [Symbol.asyncIterator]: () => asyncIterator,
            next
        };
        return asyncIterator;
    },
    serialize(iter) {
        const next = callbacks_1.Callback(() => __awaiter(this, void 0, void 0, function* () {
            const result = yield iter.next();
            if (result.done) {
                next.release();
            }
            return result;
        }));
        return {
            __iterator_marker: "$$iterator",
            next_fid: next.id
        };
    }
});
exports.isIterator = (thing) => thing && typeof thing === "object" && (typeof thing.next === "function" ||
    typeof thing[Symbol.asyncIterator] === "function");
exports.isSerializedIterator = (thing) => thing && typeof thing === "object" && "__iterator_marker" in thing && thing.__iterator_marker === "$$iterator";
