/**
 * Make sure that there is only ever one listener set on that event emitter.
 * Do so by setting a single event handler that then calls all the
 * event listeners.
 */
export declare function multiplexEventTarget(emitter: Pick<EventTarget, "addEventListener" | "removeEventListener">): {
    addEventListener: (event: string, listener: EventListener) => void;
    removeEventListener: (event: string, listener: EventListener) => void;
};
