"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const worker_threads_1 = __importDefault(require("../worker_threads"));
function assertMessagePort(port) {
    if (!port) {
        throw Error("Invariant violation: MessagePort to parent is not available.");
    }
    return port;
}
const isWorkerRuntime = function isWorkerRuntime() {
    return !worker_threads_1.default().isMainThread;
};
const postMessage = function postMessage(data, transferList) {
    assertMessagePort(worker_threads_1.default().parentPort).postMessage(data, transferList);
};
function testImplementation() {
    // Will throw if `worker_threads` are not available
    worker_threads_1.default();
}
const Implementation = {
    addEventListener(event, listener) {
        const port = assertMessagePort(worker_threads_1.default().parentPort);
        return event === "message"
            ? port.on(event, (data) => listener({ data }))
            : port.on(event, listener);
    },
    removeEventListener(event, listener) {
        const port = assertMessagePort(worker_threads_1.default().parentPort);
        return port.off(event, listener);
    },
    isWorkerRuntime,
    postMessage,
    testImplementation
};
exports.default = Implementation;
